package dev.fyloz.colorrecipesexplorer.config

import dev.fyloz.colorrecipesexplorer.config.properties.CreProperties
import dev.fyloz.colorrecipesexplorer.config.properties.MaterialTypeProperties
import dev.fyloz.colorrecipesexplorer.service.files.CachedFileSystemItem
import dev.fyloz.memorycache.ExpiringMemoryCache
import dev.fyloz.memorycache.MemoryCache
import org.springframework.boot.context.properties.EnableConfigurationProperties
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration

@Configuration
@EnableConfigurationProperties(MaterialTypeProperties::class, CreProperties::class)
class CreConfiguration(private val creProperties: CreProperties) {
    @Bean
    fun fileCache(): MemoryCache<String, CachedFileSystemItem> =
        ExpiringMemoryCache(maxAccessCount = creProperties.fileCacheMaxAccessCount)
}
